/*!
 * @file aiming_system.h
 *  Definition of
 */

#ifndef _AIMING_SYSTEM_H
#define _AIMING_SYSTEM_H


#include "world_entity.h"



// FORWARD DECLARATION
class TiXmlElement;
class BVTree;
class Model;


class AimingSystem : public WorldEntity
{

 public:
  AimingSystem(const TiXmlElement* root = NULL);
  virtual ~AimingSystem();

  void init();
  virtual void loadParams(const TiXmlElement* root);


  inline void selectTarget(PNode* target) { this->setParent(target); };
  inline PNode* getTarget(PNode* target) { return this->getParent(); };

  inline WorldEntity* getNearestTarget();


  void setRange(float range){this->range = range;};

  void hit(float damage, WorldEntity* killer);

  virtual void tick(float dt);
  virtual void draw() const;


 private:
   float                       range;                //!<
   std::vector<WorldEntity*>   selectionList;        //!< the selections


};

#endif /* _AIMING_SYSTEM_H */
